Pulp - Issue #3090

Uploading an invalid rpm produces an error message: "unexpected error occurred importing
uploaded file: 'primary™

10/20/2017 05:46 PM - daviddavis

Status: CLOSED - CURRENTRELEASE Start date:

Priority: High Due date:

Assignee: jortel@redhat.com Estimated time: 0:00 hour
Category:

Sprint/Milestone:

Severity: 2. Medium Groomed: No
Version: Sprint Candidate: No
Platform Release: 2143 Tags: Pulp 2
OS: Sprint: Sprint 28
Triaged: Yes Quarter:

Description

This is a regression that was originally fixed in https://pulp.plan.io/issues/2543. See comments below for the commit that broke this.

Steps to reproduce:

touch meerkat-2.1.0.noarch.rpm
pulp-admin rpm repo uploads rpm -f meerkat-2.1.0.nocarch.rpm —--repo-id zoo

I'd expect an error message along the lines of "couldn't parse rpm". Instead, the error message is:
Task Failed

The importer yum_importer indicated a failed response when uploading rpm unit to
repository test.

unexpected error occurred importing uploaded file: 'primary'

Related issues:
Related to Pulp - Issue #3072: Too generic "The importer yum_importer indicat... CLOSED - WONTFIX
Related to RPM Support - Issue #2543: RPM Importer swallows exception when on... CLOSED - CURRENTRELEASE

Associated revisions

Revision 4492f888 - 11/01/2017 07:44 PM - jortel@redhat.com

Raise coded exception for invalid package header. closes #3090

Revision 474781bf - 11/01/2017 07:46 PM - jortel@redhat.com

Propagate coded exceptions raised during upload. re: #3090

History

#1 - 10/20/2017 05:54 PM - daviddavis

Looks like the cause is this commit:

https://github.com/pulp/pulp_rpm/commit/62db898a81679b40e3cc3a48af9f3b830f4521cb

| reverted and the error message | get is unexpected error occurred importing uploaded file: error reading package header.

#2 - 10/20/2017 06:14 PM - daviddavis

- Related to Issue #3072: Too generic "The importer yum_importer indicated a failed response” added

#3 - 10/20/2017 06:14 PM - daviddavis

- Related to deleted (Issue #3072: Too generic "The importer yum_importer indicated a failed response”)
https://pulp.plan.io/issues/2543
https://github.com/pulp/pulp_rpm/commit/62db898a81679b40e3cc3a48af9f3b830f4521cb

#4 - 10/20/2017 06:15 PM - daviddavis

- Related to Issue #3072: Too generic "The importer yum_importer indicated a failed response” added

#5 - 10/20/2017 07:59 PM - daviddavis

Katello requested that we catch this error and raise a PulpCodedException so they can read the error details from the task[:error][:description]. | think
that seems reasonable and something that we can address with this bug fix. If not, let me know and | can open another redmine issue.

#6 - 10/20/2017 08:01 PM - daviddavis
- Description updated

- Priority changed from Normal to High

#9 - 10/24/2017 05:02 PM - dalley
- Sprint/Milestone set to 46
- Triaged changed from No to Yes

#11 - 10/30/2017 08:22 PM - jortel@redhat.com
- Status changed from NEW to ASSIGNED

- Assignee set to jortel@redhat.com

#12 - 10/31/2017 10:20 PM - jortel@redhat.com
- Status changed from ASSIGNED to POST

https://github.com/pulp/pulp/pull/3212
https://github.com/pulp/pulp_rpm/pull/1070

#13 - 11/06/2017 02:11 PM - mhrivnak
- Sprint/Milestone changed from 46 to 47

#14 - 11/14/2017 04:07 AM - jortel@redhat.com
- Status changed from POST to MODIFIED

Applied in changeset pulp_rpm:4492f888df6be5a4d4933ef66be88bf92d4eedd5.

#15 - 11/14/2017 03:41 PM - pcreech
- Platform Release set to 2.14.3

#16 - 11/16/2017 08:48 PM - pthomas@redhat.com

verified

[root@intel-sharkbay-dh-02 ~]# rpm -ga |grep pulp
python-pulp-common-2.14.3-0.1.beta.el7.noarch
python-kombu-3.0.33-8.pulp.el7.noarch
pulp-puppet-plugins-2.14.3-0.1.beta.el7.noarch
pulp-docker-admin-extensions-3.0.2-1.el7.noarch
pulp-ostree-plugins-1.3.0-1.el7.noarch
python-pulp-rpm-common-2.14.3-0.1.beta.el7.noarch
pulp-python-admin-extensions-2.0.2-1.el7.noarch
python-pulp-docker-common-3.0.2-1.el7.noarch
pulp-selinux-2.14.3-0.1.beta.el7.noarch
python-pulp-oid_validation-2.14.3-0.1.beta.el7.noarch
pulp-rpm-plugins-2.14.3-0.1.beta.el7.noarch
pulp-admin-client-2.14.3-0.1.beta.el7.noarch
python-pulp-ostree-common-1.3.0-1.el7.noarch
python-pulp-python-common-2.0.2-1.el7.noarch
pulp-python-plugins-2.0.2-1.el7.noarch
python-pulp-streamer-2.14.3-0.1.beta.el7.noarch
python-pulp-repoauth-2.14.3-0.1.beta.el7.noarch
pulp-server-2.14.3-0.1.beta.el7.noarch
python-pulp-bindings-2.14.3-0.1.beta.el7.noarch
pulp-puppet-admin-extensions-2.14.3-0.1.beta.el7.noarch
pulp-ostree-admin-extensions-1.3.0-1.el7.noarch
python-pulp-puppet-common-2.14.3-0.1.beta.el7.noarch
python-pulp-client-1ib-2.14.3-0.1.beta.el7.noarch
python-isodate-0.5.0-4.pulp.el7.noarch
pulp-docker-plugins-3.0.2-1.el7.noarch
pulp-rpm-admin-extensions-2.14.3-0.1.beta.el7.noarch
[root@intel-sharkbay-dh-02 ~]#

[root@intel-sharkbay-dh-02 ~]# touch meerkat-2.1.0.noarch.rpm
[root@intel-sharkbay-dh-02 ~]# pulp-admin rpm repo create —--repo-id zoo
Successfully created repository [zoo]

[root@intel-sharkbay-dh-02 ~]# pulp-admin rpm repo uploads rpm -f meerkat-2.1.0.noarch.rpm --repo-id zoo

Extracting necessary metadata for each request...

[ ] 100%
Analyzing: meerkat-2.1.0.noarch.rpm
completed
Creating upload requests on the server...
[ ] 100%

Initializing: meerkat-2.1.0.noarch.rpm
completed

Starting upload of selected units. If this process is stopped through ctrl+c,
the uploads will be paused and may be resumed later using the resume command or

canceled entirely using the cancel command.

Uploading: meerkat-2.1.0.noarch.rpm
completed

Importing into the repository...
This command may be exited via ctrl+c without affecting the request.

[\1

Running...
Task Failed
Error reading uploaded package header.

Deleting the upload request...
completed

#17 - 11/17/2017 02:15 PM - pcreech
- Status changed from MODIFIED to 5

#18 - 11/21/2017 03:00 PM - daviddavis

- Related to Issue #2543: RPM Importer swallows exception when one is raised during upload added

#19 - 03/09/2018 12:26 AM - bmbouter
- Sprint set to Sprint 28

#20 - 03/09/2018 12:27 AM - bmbouter
- Sprint/Milestone deleted (47)

#21 - 06/28/2018 08:23 PM - jortel@redhat.com
Failed QE. Additional PR: https://github.com/pulp/pulp_rpm/pull/1126

#22 - 06/28/2018 10:16 PM - jortel@redhat.com
- Status changed from 5 to MODIFIED

Applied in changeset pulp_rpm:f3e618b5eb0a2195ce5b31f37fe7f5ddc120bd8f.

#23 - 03/07/2019 11:09 PM - kersom

We already have test for this issue. 3090
https://github.com/pulp/pulp_rpm/pull/1126
https://github.com/PulpQE/Pulp-2-Tests/blob/9502127260fb1dedb4be4f84b2343072c671ed57/pulp_2_tests/tests/rpm/api_v2/test_upload_publish.py#L485

#24 - 03/12/2019 06:40 PM - dkliban@redhat.com
- Status changed from MODIFIED to CLOSED - CURRENTRELEASE

#25 - 04/15/2019 10:15 PM - bmbouter
- Tags Pulp 2 added
